#include <mlvalues.h>
#include <alloc.h>
#include "unix.h"
#include <time.h>

static value alloc_tm(tm)
     struct tm * tm;
{
  value res;
  res = alloc_tuple(9);
  Field_tuple(res,0) = Val_int(tm->tm_sec);
  Field_tuple(res,1) = Val_int(tm->tm_min);
  Field_tuple(res,2) = Val_int(tm->tm_hour);
  Field_tuple(res,3) = Val_int(tm->tm_mday);
  Field_tuple(res,4) = Val_int(tm->tm_mon);
  Field_tuple(res,5) = Val_int(tm->tm_year);
  Field_tuple(res,6) = Val_int(tm->tm_wday);
  Field_tuple(res,7) = Val_int(tm->tm_yday);
  Field_tuple(res,8) = tm->tm_isdst ? Val_true : Val_false;
  return res;
}

value unix_gmtime(t)             /* ML */
     value t;
{
  /*long*/ time_t clock;
  clock = Int_val(t);
  return alloc_tm(gmtime(&clock));
}

value unix_localtime(t)          /* ML */
     value t;
{
  /*long*/ time_t clock;
  clock = Int_val(t);
  return alloc_tm(localtime(&clock));
}
